var e = require("../enums/index.js"),
  a = [
    {
      name: "综合车况",
      desc: "",
      icon: "/static/images/icon_home_operation_5.png",
      url: "/pages/report-query/index",
      params: {
        title: "综合车况",
        productType: e.ProductTypeEnum.OVERALL,
        queryType: e.QueryTypeEnum.VIN,
      },
    },
    {
      name: "查维保信息",
      desc: "",
      icon: "/static/images/icon_home_operation_6.png",
      url: "/pages/report-query/index",
      params: {
        title: "查维保信息",
        productType: e.ProductTypeEnum.INSURANCE_MAINTAIN,
        queryType: e.QueryTypeEnum.VIN,
      },
    },
    {
      name: "查出险信息",
      desc: "",
      icon: "/static/images/icon_home_operation_7.png",
      url: "/pages/report-query/index",
      params: {
        title: "查出险信息",
        productType: e.ProductTypeEnum.ACCIDENT,
        queryType: e.QueryTypeEnum.VIN,
      },
    },
    {
      name: "查车辆状态",
      desc: "",
      icon: "/static/images/icon_home_operation_1.png",
      url: "/pages/vehicle-status-query/index",
      params: {
        title: "查车辆状态",
        productType: e.ProductTypeEnum.VEHICLE_STATUS,
        queryType: e.QueryTypeEnum.VIN,
      },
    },
    {
      name: "查车五项",
      desc: "",
      icon: "/static/images/icon_home_operation_4.png",
      url: "/pages/vehicle-five-query/index",
      params: {
        title: "查车五项",
        productType: e.ProductTypeEnum.VEHICLE_FIVE,
      },
    },
    {
      name: "强险投保日期",
      desc: "",
      icon: "/static/images/icon_home_operation_1.png",
      url: "/pages/sali-check-query/index",
      params: {
        title: "查交强险投保日期",
        productType: e.ProductTypeEnum.SALI_CHECK,
      },
    },
    {
      name: "商业险查询",
      desc: "",
      icon: "/static/images/icon_home_operation_2.png",
      url: "/pages/commercial-insurance-query/index",
      params: {
        title: "查商业险信息",
        productType: e.ProductTypeEnum.COMMERICAL_INSURANCE,
      },
    },
    {
      name: "交强险查询",
      desc: "",
      icon: "/static/images/icon_home_operation_3.png",
      url: "/pages/sali-query/index",
      params: { title: "查交强险信息", productType: e.ProductTypeEnum.SALI },
    },
    {
      name: "车型识别",
      desc: "",
      icon: "/static/images/icon_home_operation_8.png",
      url: "/pages/vehicle-info-query/index",
      params: {
        title: "车型识别",
        productType: e.ProductTypeEnum.VEHICLE_INFO,
      },
    },
  ],
  l = [
    {
      name: "综合车况",
      desc: "维修保养+出险事故",
      icon: "/static/images/pic_home_query_1.png",
      url: "/pages/report-query/index",
      params: {
        title: "综合车况",
        productType: e.ProductTypeEnum.OVERALL,
        queryType: e.QueryTypeEnum.VIN,
      },
    },
    {
      name: "扫描查车型",
      desc: "定型号识别高低配",
      icon: "/static/images/pic_home_query_2.png",
      url: "/pages/vehicle-info-query/index",
      params: { title: "车型识别" },
    },
    {
      name: "出险记录查询",
      desc: "识别车辆碰撞历史",
      icon: "/static/images/pic_home_query_3.png",
      url: "/pages/report-query/index",
      params: {
        title: "出险查询",
        productType: e.ProductTypeEnum.ACCIDENT,
        queryType: e.QueryTypeEnum.VIN,
      },
    },
    {
      name: "维保记录查询",
      desc: "4S店维修保养记录",
      icon: "/static/images/pic_home_query_4.png",
      url: "/pages/report-query/index",
      params: {
        title: "维保查询",
        productType: e.ProductTypeEnum.INSURANCE_MAINTAIN,
        queryType: e.QueryTypeEnum.VIN,
      },
    },
  ];
(exports.mockBlankReportList = [
  {
    date: "初登日期：未知",
    mile: "0",
    type: "出厂PDI",
    desc: "4S店无记录，注意是否试驾车的情况",
  },
]),
  (exports.mockCkdlpcList = [
    {
      name: "骨架",
      value: 0,
      key: "type1",
      icon: "/static/svgs/pic_ckpc_normal_1.svg",
    },
    {
      name: "外观",
      value: 1,
      key: "type2",
      icon: "/static/svgs/pic_ckpc_normal_2.svg",
    },
    {
      name: "发动机",
      value: 0,
      key: "type3",
      icon: "/static/svgs/pic_ckpc_normal_3.svg",
    },
    {
      name: "变速箱",
      value: 0,
      key: "type3",
      icon: "/static/svgs/pic_ckpc_normal_4.svg",
    },
    {
      name: "火烧",
      value: 0,
      key: "type4",
      icon: "/static/svgs/pic_ckpc_normal_5.svg",
    },
    {
      name: "水淹",
      value: 0,
      key: "type5",
      icon: "/static/svgs/pic_ckpc_normal_6.svg",
    },
    {
      name: "气囊",
      value: 0,
      key: "type6",
      icon: "/static/svgs/pic_ckpc_normal_7.svg",
    },
    {
      name: "加强件",
      value: 1,
      key: "type7",
      icon: "/static/svgs/pic_ckpc_normal_8.svg",
    },
  ]),
  (exports.mockCkpclbList = [
    { name: "外观", value: [], key: "wg" },
    { name: "底盘悬挂", value: [], key: "dp" },
    {
      name: "发动机",
      value: [
        { name: "发送机", type: "更换配件" },
        { name: "变速器", type: "更换配件" },
      ],
      key: "fdj",
    },
    { name: "加强件", value: [], key: "jqj" },
    { name: "气囊", value: [], key: "qn" },
    { name: "附属配件", value: [], key: "fspj" },
    { name: "骨架", value: [], key: "gj" },
    { name: "火烧", value: [], key: "hs" },
    { name: "水淹", value: [], key: "sy" },
  ]),
  (exports.mockCkxxList = [
    {
      name: "非火烧车",
      value: 0,
      key: "isFire",
      icon: "/static/svgs/icon_ckxx_normal_1.svg",
    },
    {
      name: "非泡水车",
      value: 0,
      key: "isFlood",
      icon: "/static/svgs/icon_ckxx_normal_2.svg",
    },
    {
      name: "非盗抢车",
      value: 0,
      key: "isTheft",
      icon: "/static/svgs/icon_ckxx_normal_3.svg",
    },
    {
      name: "覆盖件未损伤",
      value: 0,
      key: "isPanel",
      icon: "/static/svgs/icon_ckxx_normal_4.svg",
    },
    {
      name: "无大额赔偿",
      value: 2,
      key: "isLargeCost",
      icon: "/static/svgs/icon_ckxx_unknown_5.svg",
    },
    {
      name: "无结案记录",
      value: 0,
      key: "recordIcpending",
      icon: "/static/svgs/icon_ckxx_normal_6.svg",
    },
    {
      name: "无注销记录",
      value: 0,
      key: "recordIwriteoff",
      icon: "/static/svgs/icon_ckxx_normal_7.svg",
    },
    {
      name: "无拒赔记录",
      value: 0,
      key: "refusalRecord",
      icon: "/static/svgs/icon_ckxx_normal_8.svg",
    },
    {
      name: "交强险有效",
      value: 2,
      key: "effectiveCpi",
      icon: "/static/svgs/icon_ckxx_unknown_9.svg",
    },
    {
      name: "商业险有效",
      value: 2,
      key: "effectiveCmi",
      icon: "/static/svgs/icon_ckxx_unknown_10.svg",
    },
    {
      name: "交强险连续投保",
      value: 2,
      key: "seriesCoverCpi",
      icon: "/static/svgs/icon_ckxx_unknown_11.svg",
    },
    {
      name: "无营业记录",
      value: 0,
      key: "isBusiness",
      icon: "/static/svgs/icon_ckxx_normal_12.svg",
    },
  ]),
  (exports.mockClfwzj = {
    正前方: 1,
    正后方: 1,
    顶部: 0,
    底部: 0,
    前方左侧: 1,
    后方左侧: 0,
    中间左侧: 0,
    前方右侧: 1,
    后方右侧: 0,
    中间右侧: 0,
    内部: 0,
    其他: 0,
  }),
  (exports.mockCommercialInsuranceList = [
    { label: "保险公司", value: "中国人保" },
    { label: "保单号", value: "PDAA202214251100096236" },
    { label: "起保日期", value: "2023-11-22 16:30:00" },
    { label: "终保日期", value: "2024-11-23 00:00:00" },
    { label: "保险种类", value: "机动车第三者责任保险" },
    { label: "VIN车架号", value: "WDDBF*******40972" },
    { label: "发动机号", value: "G4F781A" },
    { label: "投保地区", value: "浙江" },
  ]),
  (exports.mockInsuranceList = [
    {
      date: "2021-02-27",
      mile: 29030,
      other: "机油放油口垫:1.00;机油滤清器:1.00;发动机机油4L(紫) 0W-20:1.00;",
      detail: "整车检查;定期维护;检查底盘、轮胎、车灯和机油;",
    },
    {
      date: "2020-09-21",
      mile: 20244,
      other:
        "发动机机油4L(紫) 0W-20:1.00;氢氧除碳-进气系统清洗剂:1.00;机油润滑系统保护剂:1.00;汽油发动机清洁剂 新国标:1.00;【GHAC】高效空调滤芯:1.00;机油润滑系统清洗剂:1.00;空气滤清器:1.00;机油放油口垫:1.00;机油滤清器:1.00;氢氧除碳-燃油系统清洗剂:1.00;",
      detail:
        "整车检查;定期维护;节气门喷嘴清洁;检查底盘、轮胎、车灯和机油;四轮动平衡;",
    },
    {
      date: "2020-06-06",
      mile: 15874,
      other: "汽油泵维修包 CV1:1.00;",
      detail: "燃油泵制造商召回;制造商活动、洗车;",
    },
    {
      date: "2020-03-15",
      mile: 12809,
      other:
        "机油放油口垫:1.00;汽油发动机清洁剂:1.00;机油滤清器:1.00;线路保护剂:1.00;发动机机油4L(紫) 0W-20:1.00;空调滤网:1.00;空调清洗剂:1.00;",
      detail:
        "检查底盘、轮胎、车灯和机油;拆卸和组装左前门和右后门;整车检查;定期维护,出事故自费,洗车;左前门、右后门、右后翼子板喷漆;空调风机的拆装;",
    },
    {
      date: "2019-09-08",
      mile: 8463,
      other:
        "汽油发动机清洁剂:1.00;机油放油口垫:1.00;发动机机油4L(紫) 0W-20:1.00;机油滤清器:1.00;调配管套件2:1.00;",
      detail:
        "整车检查;安装调整管套件;检查机箱;检查胎压灯;检查底盘、轮胎、车灯和机油;厂家活动,定期维护,机修,洗车;",
    },
    {
      date: "2019-02-23",
      mile: 3056,
      other:
        "机油滤清器:1.00;机油放油口垫:1.00;发动机机油4L（绿）0W-20:1.00;汽油发动机清洁剂 通用型:1.00;",
      detail:
        "检查前后悬架系统、转向系统、空气滤清器和空调滤芯;第一次维护;根据本田保修进行定期维护（首次定期维护）;检查空调系统、制动系统等;免费添加冷却液、制动液等;更换发动机机油、发动机机油滤清器、排放螺栓和垫片;添加汽油清洁剂;定期保养项目包括:检查整车的灯具、电器、轮胎、蓄电池、油和水;",
    },
  ]),
  (exports.mockJbxxList = [
    { label: "车身颜色", value: "黑色" },
    { label: "发动机号", value: "G3064*" },
    { label: "车辆排量", value: "2996" },
    { label: "排放标准", value: "GB18352.3-2005国Ⅳ" },
    { label: "车身结构", value: "4门5座三厢车" },
    { label: "车辆种类", value: "六座以下客车" },
    { label: "核定载客人数", value: "5" },
    { label: "初次登记日期", value: "7年及以上" },
  ]),
  (exports.mockMailList = [
    { date: "2021-02-27", mile: 29030 },
    { date: "2020-09-21", mile: 20244 },
    { date: "2020-06-06", mile: 15874 },
    { date: "2020-03-15", mile: 12809 },
    { date: "2019-09-08", mile: 8463 },
    { date: "2019-02-23", mile: 3056 },
  ]),
  (exports.mockPzlsmxList = [
    {
      date: "2019-07",
      result: [
        {
          dangerSingleType: "1",
          dangerSingleName: "雾灯护罩(前左)",
          dangerSingleMoney: "0",
          dangerSingleNum: "1",
        },
        {
          dangerSingleType: "1",
          dangerSingleName: "保险杠(前下)",
          dangerSingleMoney: "0",
          dangerSingleNum: "1",
        },
        {
          dangerSingleType: "1",
          dangerSingleName: "轮眉(前左)",
          dangerSingleMoney: "0",
          dangerSingleNum: "1",
        },
        {
          dangerSingleType: "2",
          dangerSingleName: "前杠",
          dangerSingleMoney: "0",
          dangerSingleNum: "0",
        },
        {
          dangerSingleType: "2",
          dangerSingleName: "左前叶子板",
          dangerSingleMoney: "0",
          dangerSingleNum: "0",
        },
      ],
      vin: "LVHRM3865F5017337",
      type: "",
      serviceMoney: "300000",
      claimStatus: "已结案",
    },
    {
      date: "2019-10",
      result: [
        {
          dangerSingleType: "1",
          dangerSingleName: "前保险杠皮",
          dangerSingleMoney: "0",
          dangerSingleNum: "1",
        },
        {
          dangerSingleType: "1",
          dangerSingleName: "中网",
          dangerSingleMoney: "0",
          dangerSingleNum: "1",
        },
        {
          dangerSingleType: "1",
          dangerSingleName: "前大灯（右）",
          dangerSingleMoney: "0",
          dangerSingleNum: "1",
        },
        {
          dangerSingleType: "2",
          dangerSingleName: "发动机罩",
          dangerSingleMoney: "0",
          dangerSingleNum: "1",
        },
        {
          dangerSingleType: "2",
          dangerSingleName: "前门壳",
          dangerSingleMoney: "0",
          dangerSingleNum: "1",
        },
      ],
      vin: "LVHRM3865F5017337",
      type: "",
      serviceMoney: "400000",
      claimStatus: "已结案",
    },
    {
      date: "2022-05",
      result: [
        {
          dangerSingleType: "2",
          dangerSingleName: "右后视镜座",
          dangerSingleMoney: "0",
          dangerSingleNum: "1",
        },
        {
          dangerSingleType: "2",
          dangerSingleName: "后保险杠外皮",
          dangerSingleMoney: "0",
          dangerSingleNum: "1",
        },
      ],
      vin: "LVHRM3865F5017337",
      type: "",
      serviceMoney: "100000",
      claimStatus: "已结案",
    },
  ]),
  (exports.mockSaliCheckList = [
    { label: "车牌号码", value: "粤A*****" },
    { label: "VIN车架号", value: "WDDBF*******40972" },
    { label: "号牌种类", value: "小型汽车" },
    { label: "初次投保日期", value: "2018-12-05" },
    { label: "上次交强险投保年月", value: "2022-12" },
    { label: "最近交强险投保期始", value: "2022-12-05" },
    { label: "最近交强险投保期止", value: "2023-12-05" },
  ]),
  (exports.mockSaliList = [
    { label: "保险公司", value: "中国人保" },
    { label: "投保确认码", value: "67001080120220122493" },
    { label: "保单号", value: "6140101030120220013611" },
    { label: "起保日期", value: "2023-11-22 16:30:00" },
    { label: "终保日期", value: "2024-11-23 00:00:00" },
    { label: "车牌号码", value: "粤A*****" },
    { label: "号牌种类", value: "小型汽车" },
    { label: "VIN车架号", value: "WDDBF*******40972" },
    { label: "发动机号", value: "CA04474" },
    { label: "投保地区", value: "广东" },
  ]),
  (exports.mockTjxxList = [
    { name: "事故次数", value: "3", key: "claimCount" },
    { name: "理赔总金额", value: "0万-1万", key: "totalAmount" },
    { name: "最大理赔金额", value: "0万-1万", key: "largestAmount" },
    { name: "已结案次数", value: "3", key: "claimCacCount" },
    { name: "拒赔次数", value: "0", key: "claimRejectedCount" },
  ]),
  (exports.mockVehicleFiveList = [
    { label: "车牌号码", value: "粤A*****" },
    { label: "VIN车架号", value: "WDDBF*******40972" },
    { label: "车辆品牌", value: "奔驰" },
    { label: "车辆类型", value: "小型汽车" },
    { label: "发动机号", value: "2018C9****" },
    { label: "初次登记日期", value: "2019-03-11 00:00:00" },
  ]),
  (exports.mockVehicleInfoList = [
    { label: "厂家名称", value: "奥迪(进口)" },
    { label: "车型名称", value: "Q7" },
    { label: "版本", value: "2021款 55 TFSI quattro S line运动型" },
    { label: "年款", value: "2020" },
    { label: "上市日期", value: "2020-12" },
    { label: "新车购置价格", value: "78.88万" },
    { label: "市场价", value: "-" },
    { label: "发动机型号", value: "DCB" },
    { label: "排量", value: "3.0T" },
    { label: "燃油类型", value: "汽油" },
    { label: "燃油标号", value: "95号" },
    { label: "喷射方式", value: "混合喷射" },
    { label: "最大功率 KW", value: "250" },
    { label: "最大马力(Ps)", value: "340" },
    { label: "轴距", value: "2999" },
    { label: "尺寸类型", value: "中大型SUV" },
    { label: "车身型式", value: "5门7座SUV" },
    { label: "车体结构", value: "承载式" },
    { label: "变速箱类型", value: "AT" },
    { label: "驱动方式", value: "前置四驱" },
    { label: "前轮胎尺寸", value: "285/40 R21" },
    { label: "后轮胎尺寸", value: "285/40 R21" },
    { label: "前制动类型", value: "通风盘式" },
    { label: "后制动类型", value: "通风盘式" },
    { label: "驻车制动类型", value: "电子驻车" },
    { label: "档位数", value: "无" },
    { label: "座位数", value: "7" },
    { label: "车门数", value: "5" },
    { label: "气缸数", value: "6" },
    { label: "长 mm", value: "5067" },
    { label: "宽", value: "1970" },
    { label: "高", value: "1712" },
    { label: "整备质量 kg", value: "2265" },
    { label: "是否是进口", value: "进口" },
  ]),
  (exports.mockVehicleStatusList = [
    { label: "VIN车架号", value: "WDDBF*******40972" },
    { label: "车辆状态", value: "抵押、违法未处理" },
    { label: "车辆品牌", value: "奥迪" },
  ]),
  (exports.theActionList1 = a),
  (exports.theActionList2 = l);
